# -*- coding: utf-8 -*-
"""
A generic setup script for python processing done
within each ecflow task defined in the task library
"""

import os
import importlib

if __name__ == "__main__":
    
  classname = os.getenv('class')
  action = os.getenv('action')
  module = importlib.import_module(classname)
  mytask_cls = getattr(module,classname)

  if action == 'setup': mytask_cls.py_setup_script()
  if action == 'run': mytask_cls.py_run_script()
  if action == 'finalize': mytask_cls.py_finalize_script()


