# -*- coding: utf-8 -*-
"""
MOCAGE observations class

Created on Mon Feb  6 10:29:04 2017

@author: emili
"""

from obsdb import *
import os

if __name__ == "__main__":
    
    # ---- Example of data preprocessing ----

#    PreProcessObs("GOME2","GOME2_L1B",\
#            DefPeriod('20100926','20100927'),\
#            "/home/pae/emili/scratch1/cams42/obs/GOME2/L1/knmi_06",\
#            "/home/pae/emili/scratch1/cams42/obs/GOME2/L1/knmi_06/thinned",\
#            #TimeBnd=DefPeriod('2010091500','2010091600'),\
#            #DataThinning={"Resolution":{"dlat":20,"dlon":30}},\
#            DataThinning={"Resolution":{"dlat":2.0,"dlon":2.0}},\
#            #ScatteringAngle={"Range":(120,160)},\
#            #SaveWavelengthsIn="/wkdir/pae/emili/cams42/obs/GOME2/bigscene_new_30X30/wavelengths.json",\
#            makeplots=('ObsHisto','ObsLoc','AvgSpectra'),\
#            AvgSpectraOpt={'LogScale':'symlog','linthreshy':1e-4,'range':{'spectra':{'min':1e-4,'max':1e-1},'relcov':{'min':1e-2,'max':1e2}},'varlist':['spectra','relcov']},\
#            MapProjection={"type":"robin"},MapOpt={"AddGrid":True}, \
#            #ObsLocationOpt={'markersize':3,'markercolor':'red'},
#            ObsAuxOpt={"variables":["SurfAlbedo","TotalCloudCover"],"colormap":"jet","range":{"TotalCloudCover":{"min":0,"max":1}}}, \
#            ObsHistoOpt={"npltsperpage":6,"spectral":{"wavelengths":[328.9,315.18,305.04,295.01,287.77,270.1]},'varlist':['spectra','relcov']},\
#            ObsOnMapOpt={"npltsperpage":6,"markersize":4,"spectral":{"wavelengths":[328.9,315.18,305.04,295.01,287.77,270.1]},\
#                                                   "range":{"spectra":{"type":"FuncOfWl",\
#                                                   "WlRegions":[(265,295),(295,315),(315,338)],\
#                                                   "limits":[(1e-4,1e-5),(5e-3,5e-2),(1e-2,1e-1)]},\
#                                                   "relcov":{"min":0,"max":50}},\
#                                                   'varlist':['spectra','relcov']}\
#            )

#    PreProcessObs("GOME2-O3M","GOME2_O3M", \
#            DefPeriod('20100926','20100927'),\
#            "/home/pae/emili/scratch1/cams42/obs/GOME2/L2/knmi_02/colocated_with_L1_thinned", \
#            "/home/pae/emili/scratch1/cams42/obs/GOME2/L2/knmi_02/colocated_with_L1_thinned/topcut",\
#            #makeplots=('ObsLoc','ObsOnMap','ObsHisto','AvgVertProfiles','NObsTimeSer','AvgAuxProfiles','AuxOnMap'),\
#            makeplots=('ObsLoc','AvgVertProfiles','ObsHisto','AvgAuxProfiles'),\
#            #SumColumns={},\
#            LevelsSelection=[1,9,14,18,21,24,30,35,39],\
#            #LevelsSelection=[1,4,9,14,18],\
#            #LevelsSelection=[1,4,9],\
#            #LevelsSelection=[0,1,2,3,4,5,6,7,8,9,10,14,18,21,24,30,35],\
#            #DataThinning={"Resolution":{"dlat":20,"dlon":30}},\
#            #DataThinning={"Resolution":{"dlat":2.0,"dlon":2.0}},\
#            PressBnd={'min':50,'max':103000},\
#            AvkPressBnd={'min':10,'max':103000},\
#            #VertProfilesOpt={'xrange':{'max':1e2,'min':1e-4},'yrange':{'max':1e-3,'min':1.1e3},'xlog':True},\
#            VertProfilesOpt={'printdata':False,'xrange':{'max':1e2,'min':1e-4},'yrange':{'max':1e-3,'min':1.1e3},'xlog':True},\
#            AuxProfilesOpt={'avkrange':{'max':0.3,'min':-0.2},'covrange':{'max':1e2,'min':1e-4,'xlog':True},'yrange':{'max':1e-3,'min':1.1e3}},\
#            ObsOnMapOpt= {"figsize":(15,15),"markersize":1,\
#                          "AvkTrace":{"range":{"max":3.1,"min":2.3}},\
#                          },\
#            MapProjection={"type":"robin"}, \
#            )
    
#    PreProcessObs("MLS","ProfConcInstrument",\
#            DefPeriod('20080801','20080802'),\
#            "/archive/pae/daimon/ASSIMILATION_TESTCASES/test1/input",\
#            "/home/pae/emili/scratch1/DAIMON/tests/test1mod",\
#            #makeplots=('ObsLoc','AvgVertProfiles'), \
#            TimeBnd=DefPeriod('2008080200','2008080206'),\
#            ObsLocationOpt={'markersize':10,'markercolor':'red'}, \
#            VertProfilesOpt={'xrange':{'max':1e5,'min':0.1},'yrange':{'max':0.01,'min':1.1e3},'xlog':True,'ylog':True,'printdata':True} \
#            )

    # Example of obs colocator
    
#    dates = ['201009%02i' % (i) for i in range(26,27)]
###   
##    instrtype2 = {"name":"IASI","type":"IASI_L1C","kwargs":{}}
##    inputdir2 = "/archive/pae/emili/radiances/obs/paper-v1.6"
##    outputdir2 = "/archive/pae/emili/radiances/obs/IASI/xxx"
##    inputdir2 = "/archive/pae/emili/radiances/obs/IASI-L1c/paper/thinned-v3.0"
##    outputdir2 = "/archive/pae/emili/radiances/obs/IASI-L1c/paper/thinned-v3.0-withSOFRIDSkinTemp"
##    instrtype1 = {"name":"IASI-SOFRID","type":"SOFRIDProfInstrument","kwargs":{}}
##    inputdir1 = "/archive/pae/emili/radiances/obs/IASI-SOFRID/v3.0-clearsky-withSkinTemp"
##    outputdir1 = "/archive/pae/emili/radiances/obs/IASI-SOFRID/v3.0-clearsky-withSkinTemp/thinned"
#    instrtype1 = {"name":"GOME2-O3M","type":"GOME2_O3M","kwargs":{}}
#    instrtype2 = {"name":"GOME2","type":"GOME2_L1B","kwargs":{}}
#    inputdir1 = "/scratch/ae/emili/cams42/obs/GOME2/L2/knmi_02"
#    outputdir1 = "/scratch/ae/emili/cams42/obs/GOME2/L2/knmi_02/colocated_with_L1_thinned"
#    inputdir2 = "/scratch/ae/emili/cams42/obs/GOME2/L1/knmi_06/thinned"
#    outputdir2 = "/scratch/ae/emili/cams42/obs/GOME2/L1/knmi_06/thinned_and_colocated_with_L2"
#
#### #
#    for date in dates:
##       
#        instr1 = DefInstrument(instrtype1["name"],instrtype1["type"],**instrtype1["kwargs"])
#        instr1.Read(os.path.join(inputdir1,"HDAT+"+date+".h5"))
#       
#        instr2 = DefInstrument(instrtype2["name"],instrtype2["type"],**instrtype2["kwargs"])
#        instr2.Read(os.path.join(inputdir2,"HDAT+"+date+".h5"))
#       
#        instr1.Select(Colocation={"DataList":(instr2,),"Accelerate":True,"StoreMatrix":True})
#        instr2.Select(Colocation={"DataList":(instr1,),"Accelerate":True,"UseMatrix":True})
#        
#        outputfile = os.path.join(outputdir1,"HDAT+"+date+".h5")
#        instr1.Plot(outdir=outputdir1,makeplots=['ObsLoc','NObsTimeSer'],MapProjection={"type":"robin"})#,PlotRegion={"LatMax":75.0,"LatMin":28.0,"LonMax":36,"LonMin":-16})
#        instr1.Write(outputfile)
#       
#        outputfile = os.path.join(outputdir2,"HDAT+"+date+".h5")
#        instr2.Plot(outdir=outputdir2,makeplots=['ObsLoc','NObsTimeSer'],MapProjection={"type":"robin"})#,PlotRegion={"LatMax":75.0,"LatMin":28.0,"LonMax":36,"LonMin":-16})
#        instr2.Write(outputfile)
#        
#        instr1 = None
#        instr2 = None
        
    # PreProcessObs('IASI','IASI_L1C',\
    #              DefPeriod('20101201','20110101'),\
    #              "/scratch/ae/emili/o3reanl/obs/iasi-l1c/2010-avhrrcldmsk",\
    #              "/scratch/ae/emili/o3reanl/obs/iasi-l1c/2010-avhrrcldmsk-thinned",\
    #              DataThinning={"Bounds":{"LatMax":90.0,"LatMin":-90.0,"LonMax":180.0,"LonMin":-180.0},"Resolution":{"dlon":2.0,"dlat":2.0}},\
    #              #DataThinning={"Resolution":{"dlat":0.4,"dlon":0.4}},\
    #              makeplots=['NObsTimeSer','ObsLoc'],\
    #              #PlotRegion={"LatMax":75.0,"LatMin":28.0,"LonMax":36,"LonMin":-16},
    #              MapProjection={"type":"robin"} \
    #              )
        
    # Dirty handmade SkinTemperature substitution in IASIL1c files for paper review
#    import numpy as np
#    inputdir1 = "/archive/pae/emili/radiances/obs/IASI-SOFRID/v3.0-clearsky-withSkinTemp/thinned"
#    for date in dates:
#         
#        instr1 = DefInstrument(instrtype1["name"],instrtype1["type"],**instrtype1["kwargs"])
#        instr1.Read(os.path.join(inputdir1,"HDAT+"+date+".h5"))
#       
#        instr2 = DefInstrument(instrtype2["name"],instrtype2["type"],**instrtype2["kwargs"])
#        instr2.Read(os.path.join(inputdir2,"HDAT+"+date+".h5"))
#        
#        # Since obs times is not equal between SOFRID and IASIL1c I need to find the correspondent lat-lon couples
#        # Reordered indexes does the job
#        sorted_idx1 = np.lexsort((instr1.lons,instr1.lats))
#        sorted_idx2 = np.lexsort((instr2.lons,instr2.lats))
#        
#        instr2.SurfSkinTemperature[sorted_idx2] = instr1.SurfSkinTemperature[sorted_idx1]
#        
#        outputfile = os.path.join(outputdir2,"HDAT+"+date+".h5")
#        instr2.Write(outputfile)
        
##
#    dates = ['201007%02i' % (i) for i in range(31,32)]
###   
##    instrtype1 = {"name":"IASI","type":"IASI_L1C","kwargs":{}}
##    inputdir1 = "/wkdir/pae/emili/radiances/obs/IASI/paper/thinned"
#    instrtype1 = {"name":"IASI-SOFRID","type":"SOFRIDProfInstrument","kwargs":{}}
#    inputdir1 = "/wkdir/pae/emili/radiances/obs/IASI-SOFRID/paper-v1.6/thinned_with_l1"
##    instrtype2 = {"name":"IASI-SOFRID","type":"SOFRIDProfInstrument","kwargs":{}}
##    inputdir2 = "/wkdir/pae/emili/radiances/obs/IASI-SOFRID/paper-v1.6"
#    instrtype2 = {"name":"IASI","type":"IASI_L1C","kwargs":{}}
#    inputdir2 = "/wkdir/pae/emili/radiances/obs/IASI/paper/thinned"
##    outputdir = "/wkdir/pae/emili/radiances/obs/IASI-SOFRID/paper-v1.6/thinned_with_l1"
#    outputdir = "/wkdir/pae/emili/radiances/obs/IASI/paper/recolocated_with_thinned_v1.6"
##
### #
#    for date in dates:
#       
#        instr1 = DefInstrument(instrtype1["name"],instrtype1["type"],**instrtype1["kwargs"])
#        instr1.Read(os.path.join(inputdir1,"HDAT+"+date+".h5"))
#       
#        instr2 = DefInstrument(instrtype2["name"],instrtype2["type"],**instrtype2["kwargs"])
#        instr2.Read(os.path.join(inputdir2,"HDAT+"+date+".h5"))
#       
#        instr2.Select(Colocation={"DataList":(instr1,),"Accelerate":True,"UseMatrix":False})
#        
#        outputfile = os.path.join(outputdir,"HDAT+"+date+".h5")
#        instr2.Plot(outdir=outputdir,makeplots=['ObsLoc','NObsTimeSer'],MapProjection={"type":"robin"})#,PlotRegion={"LatMax":75.0,"LatMin":28.0,"LonMax":36,"LonMin":-16})
#        instr2.Write(outputfile)
#        instr1 = None
#        instr2 = None
#
#    PreProcessObs("IASI-SOFRID","SOFRIDProfInstrument",\
#                DefPeriod('20100714','20100715'),\
#                "/wkdir/pae/emili/radiances/obs/IASI-SOFRID/debug_newdist_m",\
#                "/wkdir/pae/emili/radiances/obs/IASI-SOFRID/debug_newdist_m/thinned",\
#                #DataThinning={"Resolution":{"dlat":0.4,"dlon":0.4}},\
#                DataThinning={"Bounds":{"LatMax":90.0,"LatMin":-90.0,"LonMax":180.0,"LonMin":-180.0},"Resolution":{"dlon":2.0,"dlat":2.0}},\
#                makeplots=['NObsTimeSer','ObsLoc'],\
#                #PlotRegion={"LatMax":75.0,"LatMin":28.0,"LonMax":36,"LonMin":-16},
#                MapProjection={"type":"robin"} \
#                )
        
    # ---- Example of hdf5 aggregators ----
    
    # AggregateHdf5(["/scratch/ae/emili/seeds/obs/AIRBASE/"+spc+"/HDAT+20100711.h5" \
    #               for spc in ["O3","CO","NO2"]], \
    #               "/scratch/ae/emili/seeds/obs/AIRBASE/HDAT+20100711.h5")

    AggregateHdf5(["/scratch/ae/emili/seeds/obs/AIRBASE_Validation/HDAT+20100715.h5", \
                   "/scratch/ae/emili/seeds/obs/AIRBASE/HDAT+20100715.h5"], \
                  "/scratch/ae/emili/seeds/obs/AIRBASE_All/HDAT+20100715.h5")

    
#    AggregateHdf5(["/wkdir/pae/emili/radiances/obs/MLS+AIRBASE+RADIOSONDES/HDAT+20100707.h5", \
#                   "/wkdir/pae/emili/radiances/obs/IASI/fixed/HDAT+20100707.h5"], \
#                   "/wkdir/pae/emili/radiances/obs/IASI/fixed_and_obsforval/HDAT+20100707.h5")
    
#    AggregateHdf5(["/home/pae/emili/scratch1/DAIMON/tests/test1mod/HDAT+20080801_MLScut.h5", \
#                   "/archive/pae/daimon/ASSIMILATION_TESTCASES/test1/input/HDAT+20080801.h5"], \
#                   "/home/pae/emili/scratch1/DAIMON/tests/test1mod/HDAT+20080801.h5")
    
#    AggregateHdf5([ \
#               "/archive/pae/emili/radiances/obs/MLS/MOCAGE60NIV/HDAT+20100701.h5",\
#               "/archive/pae/emili/radiances/obs/RADIOSONDES/current/HDAT+20100701.h5",\
#               "/archive/pae/emili/radiances/obs/IASI-SOFRID/paper-v3.0/thinned_with_l1/HDAT+20100701.h5", \
#               "/archive/pae/emili/radiances/obs/IASI-L1c/paper/recolocated_with_thinned_v3.0/HDAT+20100701.h5"],\
#               "/archive/pae/emili/radiances/obs/paper-v3.0/HDAT+20100701.h5" )

#    AggregateHdf5(["/home/pae/emili/scratch1/cams42/obs/GOME2/L1/knmi_06/thinned_and_colocated_with_L2/HDAT+20100926.h5", \
#               "/home/pae/emili/scratch1/cams42/obs/GOME2/L2/knmi_02/colocated_with_L1_thinned/topcut/HDAT+20100926.h5",\
#               "/archive/pae/emili/cams42/obs/MLS/current/HDAT+20100926.h5", \
#               "/archive/pae/emili/cams42/obs/RADIOSONDES/current/HDAT+20100926.h5"],\
#               "/home/pae/emili/scratch1/cams42/obs/merged/04/HDAT+20100926.h5")

    # Aggregators read multiple hdf5 file as input and output one single hdf5 
    # file containing all instruments
#    AggregateInstr(['/archive/pae/emili/radiances/obs/MLS/MOCAGE60NIV',\
#                        '/archive/pae/emili/radiances/obs/RADIOSONDES/current',\
##                        '/wkdir/pae/emili/radiances/obs/AIRBASE/O3',\
#                        '/archive/pae/emili/radiances/obs/IASI-SOFRID/v3.0-clearsky-withSkinTemp/thinned',\
#                        '/archive/pae/emili/radiances/obs/IASI-L1c/paper/thinned-v3.0-withSOFRIDSkinTemp'],\
#                       outdir='/archive/pae/emili/radiances/obs/paper-v3.0-sameSkinTemp', \
#                       filefreq="daily")
    
#    AggregateInstr(['/wkdir/pae/emili/cams42/obs/MLS/current',\
#                        '/wkdir/pae/emili/cams42/obs/RADIOSONDES/current'],\
#                       outdir='/wkdir/pae/emili/cams42/obs/MLS+RADIOSONDES', \
                      # filefreq="daily")
    # AggregateInstr(['/scratch/ae/emili/o3reanl/obs/iasi-l1c/2010-thinned',\
    #                   '/scratch/ae/emili/o3reanl/obs/MLS/01',\
    #                   '/scratch/ae/emili/o3reanl/obs/ozonesondes/01'],\
    #                  outdir='/scratch/ae/emili/o3reanl/obs/merged/2010', \
    #                  filefreq="daily",period=("20101101","20110101"))
    
#    AggregateInstr(['/scratch/ae/emili/cams42/obs/GOME2/L1/knmi_06/thinned_and_colocated_with_L2',\
#                        '/scratch/ae/emili/cams42/obs/GOME2/L2/knmi_02/colocated_with_L1_thinned/topcut',\
#                        '/archive/pae/emili/cams42/obs/MLS/current',\
#                        '/archive/pae/emili/cams42/obs/RADIOSONDES/current'],\
#                         outdir='/scratch/ae/emili/cams42/obs/merged/04',\
#                         filefreq="daily")
    
#    AggregateInstr(['/scratch/ae/emili/cams42/obs/GOME2/L1/knmi_06/thinned_and_colocated_with_L2',\
#                        '/scratch/ae/emili/cams42/obs/GOME2/L2/knmi_02/colocated_with_L1_thinned/topcut',\
#                        '/scratch/ae/emili/uvir/obs/iasi-l1c/01/thinned2x2_withR',\
#                        '/archive/pae/emili/cams42/obs/MLS/current',\
#                        '/archive/pae/emili/cams42/obs/RADIOSONDES/current'],\
#                         outdir='/scratch/ae/emili/uvir/obs/merged/02',\
#                         filefreq="daily")
    
    # ---- Examples of observation generators ---- 
    
    # Generate obs from previos H output
    
#    GenerateObs('GOME2','GOME2_L1B',\
#                "/archive/pae/emili/cams42/obs/GOME2/radiances/synthetic/truth_24",ProductName="KNMI",\
#                FromFile = {"filename":"/home/pae/emili/scratch/DAIMON/RESULTS/cams42/assim-synthetic/truth_24/HSTAT+2010091500+2010091524.h5"},\
#                ReadAssim = {'Region':'GLOB22','ObsType':'Hx_dry','Diagnostics':True},\
#                )
    
#    GenerateObs('GOME2','GOME2_L1B',\
#                "/home/pae/emili/scratch/cams42/obs/GOME2/L1/synthetic/truth_50",ProductName="KNMI",\
#                FromTwoFiles = {"filename1":"/home/pae/emili/scratch/cams42/obs/GOME2/L1/knmi_03/verythinned/HDAT+20100915.h5",
#                                "filename2":"/home/pae/emili/scratch/cams42/synthetic/truth_40/HSTAT+2010091500+2010091524.h5"},\
#                Perturb = True,\
#                ReadAssim = {'Region':'GLOB22','ObsType':'Hx_dry','Diagnostics':True},\
#                makeplots=('AvgSpectra','ObsLoc'), \
#                AvgSpectraOpt={'LogScale':'log','range':{'spectra':{'min':1e-5,'max':1e-1},'relcov':{'min':1e-2,'max':1e2}},'varlist':['spectra','relcov']},\
#                MapProjection={"type":"robin"},MapOpt={"AddGrid":True}, \
#                )
    
#    GenerateObs('IASI','IASI_L1C',\
#                "/wkdir/pae/emili/radiances/obs/IASI_SYNTH/truth_0102",\
#                FromFile = {"filename":"/wkdir/pae/emili/radiances/simu/test8_truth_0102/HSTAT+2010070706+2010070714.h5"},\
#                ReadAssim={'Region':'GEMS02','ObsType':'Hx_dry'},\
#                makeplots=('ObsHisto','ObsLoc','ObsOnMap','ObsAux','AvgSpectra'),\
#                PlotRegion={"LatMax":75.0,"LatMin":28.0,"LonMax":36,"LonMin":-16},\
#                MapProjection={"type":"cyl"} \
#                )
    
    pass